package skyrix;

import java.util.Date;
import java.util.Hashtable;

/**
 * @author <a href="mailto:loutchan@skyrix.com">Eileen Loutchan</a>
 * @version $Revision: $
 */
public class Job 
{
	/**Eindeutige Kennzeichnung von einem Job.*/
	private String id = null;
  
	/**Bezeichnung fr einen Job.*/
	private String name = null;
  
	/**Startzeitpunkt eines Jobs.*/
	private Date startDate = null;
  
	/**Endzeitpunkt eines Jobs.*/
	private Date endDate = null;
	
	/**Konstruktor.
	 * 
	 * @param id Eindeutige Kennzeichnung.
	 * @param name Bezeichnung fr einen Job.
	 * @param startDate Startzeitpunkt eines Jobs.
	 * @param endDate Endzeitpunkt eines Jobs.
	 */
	public Job(String id, String name, Date startDate, Date endDate)
	{
		super();
		this.id = id;
		this.name = name;
		this.startDate = startDate;
		this.endDate = endDate;	
	}
	
	/**Gibt die eindeutige ID fr einen Job zurck.
	 * 
	 * @return String ID fr einen Job.
	 */
	public String getID()
	{
		return id;
	}

	/**Methode setzt eine eindeutige ID fr einen Job.
	 * 
	 * @param id ID die fr diesen Job gesetzt werden soll.
	 */
	public void setID(String id)
	{
		this.id = id;
	}
	
	/**Gibt die Bezeichnung fr einen Job zurck.
	 * 
	 * @return String Bezeichnung fr einen Job.
	 */
	public String getName()
	{
		return name;
	}

	/**Methode setzt eine Bezeichnung fr einen Job.
	 * 
	 * @param title Bezeichnung fr einen Job.
	 */
	public void setName(String name)
	{
		this.name = name;
	}
	
	/**Gibt den Startzeitpunkt fr einen Job zurck.
	 * 
	 * @return Date Zeitpunkt an dem der Job beginnt.
	 */
	public Date getStartDate()
	{
		return startDate;
	}

	/**Methode setzt den Startzeitpunkt fr einen Job.
	 * 
	 * @param startDate Zeitpunkt an dem der Job beginnen soll.
	 */
	public void setStartDate(Date startDate)
	{
		this.startDate = startDate;
	}

	/**Gibt den Endzeitpunkt fr einen Job zurck.
	 *
	 * @return Date Zeitpunkt an dem der Job endet.
	 */
	public Date getEndDate()
	{
		return endDate;
	}

	/**Methode setzt den Endzeitpunkt fr einen Job.
	 *
	 * @param endDate Zeitpunkt an dem der Job enden soll.
	 */
	public void setEndDate(Date endDate)
	{
		this.endDate = endDate;
	}
	
	/**Methode erstellt ein Job - Objekt.
	 * 
	 * @param dataHash Container mit den notwendigen Daten.
	 * @return Job Job - Objekt
	 */
	public static Job createJob(Hashtable dataHash)
	{
		try
		{
			String id = (String)dataHash.get("id");
			String name = (String)dataHash.get("name");
			Date startDate = (Date)dataHash.get("startDate");
			Date endDate = (Date)dataHash.get("endDate");

			return new Job(id,
										 name,
										 startDate,
										 endDate);
		}
		catch(Exception ex)
		{
		}
		return null;
	}
  
	/**Stringreprsentation des Objektes.
	 * 
	 * @return Gibt die Bezeichnung fr einen Job zurck.
	 */
	public String toString()
	{
		return name; 
	}
}
