package skyrix;

import java.util.Hashtable;

/**
 * @author <a href="mailto:loutchan@skyrix.com">Eileen Loutchan</a>
 * @version $Revision: $
 */
public class Person 
{
	/**Eindeutige Kennzeichnung von einer Person.*/
	private String id = null;
  
	/**Vorname einer Person.*/
	private String firstName = null;
  
	/**Nachname einer Person.*/
	private String name = null;
	
	/**Konstruktor.
	 * 
	 * @param id Eindeutige Kennzeichnung.
	 * @param firstName Vorname einer Person.
	 * @param name Nachname einer Person.
	 */
	public Person(String id, String firstName, String name)
	{
		super();
		this.id = id;
		this.firstName = firstName;
		this.name = name;	
	}
	
	/**Gibt die eindeutige ID fr eine Person zurck.
	 * 
	 * @return String ID fr eine Person.
	 */
	public String getID()
	{
		return id;
	}
	
	/**Gibt den Vornamen einer Person zurck.
	 * 
	 * @return String Vorname einer Person.
	 */
	public String getFistName()
	{
		return firstName;
	}
	
	/**Gibt den Nachnamen einer Person zurck.
	 * 
	 * @return String Nachname einer Person.
	 */
	public String getName()
	{
		return name;
	}
	
	/**Methode erstellt ein Person - Objekt.
	 * 
	 * @param dataHash Container mit den notwendigen Daten.
	 * @return Person Person - Objekt
	 */
	public static Person createPerson(Hashtable dataHash)
	{
		try
		{
			String id = (String)dataHash.get("id");
			String firstName = (String)dataHash.get("firstname");
			String name = (String)dataHash.get("name");

			return new Person(id, firstName, name);
		}
		catch(Exception ex)
		{
		}
		return null;
	}
  
	/**Stringreprsentation des Objektes.
	 * 
	 * @return Gibt Vor- und Nachnamen einer Person zurck.
	 */
	public String toString()
	{
		return firstName+" "+name; 
	}
}
