package skyrix.gui;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.AbstractButton;
import javax.swing.Icon;
import javax.swing.JButton;


public class HoverButton extends JButton
{
  public HoverButton()
  {
    super();
    setMouseListeners(this);
  }

  public HoverButton(Icon icon)
  {
    super(icon);
    setMouseListeners(this);
  }

  public HoverButton(String text)
  {
    super(text);
    setMouseListeners(this);
  }

  public HoverButton(String text, Icon icon)
  {
    super(text, icon);
    setMouseListeners(this);
  }

  private void setMouseListeners(AbstractButton btn)
  {
    btn.addMouseListener(new MouseAdapter()
      {
        public void mouseEntered(MouseEvent e)
        {
          AbstractButton abstractbutton = (AbstractButton)e.getSource();
          if(abstractbutton.isEnabled())
          {
            abstractbutton.setBorderPainted(true);
          }
        }

        public void mouseExited(MouseEvent e)
        {
          AbstractButton abstractbutton = (AbstractButton)e.getSource();
          if(abstractbutton.isEnabled())
          {
            ((AbstractButton)e.getSource()).setBorderPainted(false);
          }
        }
      }
    );
    btn.setBorderPainted(false);
  }

  public void setEnabled(boolean enable)
  {
    super.setEnabled(enable);
    setBorderPainted(false);
  }
}
