package skyrix.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

/**
 * @author <a href="mailto:loutchan@skyrix.com">Eileen Loutchan</a>
 * @version $Revision: $
 */
public class LoginDialog extends JDialog 
{
  /**Url vom Server.*/
  private JTextField url = null;
  
  /**Loginname.*/
	private JTextField login = null;

  /**Loginpasswort.*/
  private JPasswordField password = null;
  
  /**True wenn der OK Button bettigt wurde, false sonst.*/ 
  private boolean hasCommitted = false;
  
	/**Konstruktor.
	 * 
	 * <p>Erstellt die GUI.</p>
	 * 
	 * @param owner Elternfenster der Komponente.
	 * @param title Titel fr den Dialog
	 * @param modal True der Dialog bleibt im Vordergrund.
	 */
	public LoginDialog(Frame owner, String title, boolean modal) 
	{
		super(owner, title, modal);
		
		getContentPane().setLayout(new BorderLayout());
    
    JPanel loginPanel = new JPanel();
    
    JLabel urlLabel = new JLabel("Server url:");
    url = new JTextField(); 	  	
    url.setText("http://marvin:30147/RPC2");
		
		JLabel loginLabel = new JLabel("Login:");
		login = new JTextField();
		login.setText("root");
		
		JLabel passwordLabel = new JLabel("Password:");
		password = new JPasswordField();
		
	
		GridBagLayout gbl = new GridBagLayout();
		loginPanel.setLayout(gbl);
    
		GridBagConstraints c = new GridBagConstraints();
		c.insets = new Insets(10,5,10,15);// Abstnde definieren
		c.weightx = 10;                  // Breite
		c.weighty = 0;                  // Hhe
		c.gridx = 0;                     // x-Position
		c.gridy = 0;                     // y-Position
		c.gridwidth = 1;                 // Breite
		c.gridheight = 1;                // Hhe
		c.fill = GridBagConstraints.HORIZONTAL; // wie Komponente Bereich fllen soll
		gbl.setConstraints(urlLabel, c);  //zum GridBagConstraints hinzufgen
		loginPanel.add(urlLabel);

		c.weightx = 90;                 // Breite
		c.weighty = 0;                  // Hhe
		c.gridx = 1;
		c.gridy = 0;
		c.gridwidth = 1;
		c.gridheight = 1;
		gbl.setConstraints(url, c);
		loginPanel.add(url);

		c.weightx = 0;                  // Breite
		c.weighty = 0;                  // Hhe
		c.gridx = 0;
		c.gridy = 1;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.anchor = GridBagConstraints.NORTHWEST;
		gbl.setConstraints(loginLabel, c);
		loginPanel.add(loginLabel);

		c.weightx = 0;                  // Breite
		c.weighty = 0;                  // Hhe
		c.gridx = 1;
		c.gridy = 1;
		c.gridwidth = 1;
		c.gridheight = 2;
		c.fill = GridBagConstraints.BOTH;
		gbl.setConstraints(login, c);
		loginPanel.add(login);

		c.weightx = 0;                  // Breite
		c.weighty = 0;                  // Hhe
		c.gridx = 0;
		c.gridy = 3;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.fill = GridBagConstraints.HORIZONTAL;
		gbl.setConstraints(passwordLabel, c);
		loginPanel.add(passwordLabel);

		c.weightx = 0;                  // Breite
		c.weighty = 0;                  // Hhe
		c.gridx = 1;
		c.gridy = 3;
		c.gridwidth = 1;
		c.gridheight = 1;
		gbl.setConstraints(password, c);
		loginPanel.add(password);

		URL okImageFile = getClass().getResource("images/ok.gif");
		URL cancelImageFile = getClass().getResource("images/cancel.gif");

		HoverButton connect = null;
		if(okImageFile != null && cancelImageFile != null)
		{
			connect = new HoverButton("OK", new ImageIcon(okImageFile));
		}
		else connect = new HoverButton("OK");
    
		connect.setToolTipText("Connect");
		connect.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					okButtonClicked();
				} 
			}
		);
    
		HoverButton cancel = null;
		if(okImageFile != null && cancelImageFile != null)
		{
			cancel = new HoverButton("Cancel", new ImageIcon(cancelImageFile));
		}
		else cancel = new HoverButton("Cancel");
    
		cancel.setToolTipText("Cancel");
		cancel.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					cancelButtonClicked();
				}
			}
		);

		JPanel buttonPanel1 = new JPanel(new GridLayout(1, 2));    
		buttonPanel1.add(connect);
		buttonPanel1.add(cancel);
    
		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		buttonPanel.add(buttonPanel1);

    getContentPane().add(loginPanel, BorderLayout.CENTER);
		getContentPane().add(buttonPanel, BorderLayout.SOUTH);
	}

  /**Methode wird aufgerufen, um sich mit dem Server
   * zuverbinden.*/
  private void okButtonClicked()
  {
  	try
  	{
			String serverUrl = null;
			if(url.getText().trim().equals(""))
			{
				JOptionPane.showMessageDialog(this,
																			"You must fill the server url field.",
																			"Information...",
																			JOptionPane.INFORMATION_MESSAGE);
			}
			else
				serverUrl = url.getText();

			if(serverUrl == null) return;

			String loginName = null;
			if(login.getText().trim().equals(""))
			{
				JOptionPane.showMessageDialog(this,
																			"You must fill the login field.",
																			"Information...",
																			JOptionPane.INFORMATION_MESSAGE);
			}
			else
				loginName = login.getText();

			if(loginName == null) return;
      			
			hasCommitted = true;	    
			setVisible(false);
  	}
  	catch(Exception e)
  	{
  	}
  }
  
  /**Methode wird aufgerufen, wenn der Anmeldevorgang
   * abgebrochen werden soll.*/
  private void cancelButtonClicked()
  {
		hasCommitted = false;
		setVisible(false);
  }
  
  /**Gibt den Benutzernamen zurck.
   *
   * @return Benutzername.
   */ 
  public String getUserName()
  {
  	return login.getText().trim();
  }
  
	/**Gibt die Server Url zurck.
	 *
	 * @return Server Url.
	 */ 
  
  public String getServerURL()
  {
    return url.getText().trim();
  }
  
  /**Gibt das Passwort zurck.
   * 
   * @return Passwort.
   */
  public char[] getPassword()
  {
  	return password.getPassword();
  }
  
  /**Gibt die Aktion des Benutzers zurck.
   * 
   * @return True der Loginvorgang soll fortgesetzt werden, false sonst.
   */
  public boolean hasCommitted()
  {
    return hasCommitted;	
  }
}
