package skyrix.gui.lf;

import java.awt.Font;

import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.FontUIResource;
import javax.swing.plaf.metal.DefaultMetalTheme;


public class DefaultTheme extends DefaultMetalTheme 
{
    public String getName() { return "Default Organizer theme"; }
    
    private final ColorUIResource primary1    = new ColorUIResource(0xFF, 0xDA, 0xAA);
    private final ColorUIResource primary2    = new ColorUIResource(0xFC, 0xF8, 0xDF);
    private final ColorUIResource primary3    = new ColorUIResource(0xFA, 0xE8, 0xB8);
    
    private final ColorUIResource secondary1  = new ColorUIResource(0xD0, 0xD0, 0xD0);
    private final ColorUIResource secondary2  = new ColorUIResource(0xFF, 0xDA, 0xAA);
    private final ColorUIResource secondary3  = new ColorUIResource(0xFF, 0xFF, 0xF0);
  
    private final FontUIResource windowTitleFont = new FontUIResource("Verdana", Font.BOLD, 14);
    private final FontUIResource controlFont   = new FontUIResource("Verdana", Font.PLAIN, 11);

    protected ColorUIResource getPrimary1() { return primary1; }  
    protected ColorUIResource getPrimary2() { return primary2; } 
    protected ColorUIResource getPrimary3() { return primary3; } 
    
    protected ColorUIResource getSecondary1() { return secondary1; }
    protected ColorUIResource getSecondary2() { return secondary2; }
    protected ColorUIResource getSecondary3() { return secondary3; }
    
    public FontUIResource getWindowTitleFont() { return windowTitleFont;}
    public FontUIResource getMenuTextFont() { return controlFont;}
    public FontUIResource getControlTextFont() { return controlFont;}
}

